/*
 * $Id: zipfile1.C,v 1.6 2000/06/01 02:24:51 lculik Exp $
 */

/*
 * Harbour Project source code:
 * HB_ZIPFILE() FUNCTION Harbour zip file compress function
 *
 * Copyright 2000 Luiz Rafael Culik <culik@sl.conex.net>
 * www - http://www.harbour-project.org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version, with one exception:
 *
 * The exception is that if you link the Harbour Runtime Library (HRL)
 * and/or the Harbour Virtual Machine (HVM) with other files to produce
 * an executable, this does not by itself cause the resulting executable
 * to be covered by the GNU General Public License. Your use of that
 * executable is in no way restricted on account of linking the HRL
 * and/or HVM code into it.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA (or visit
 * their web site at http://www.gnu.org/).
 *
 */

#include "hbzip.h"

HB_FUNC(HB_ZIPFILE)
{

    if( ISCHAR(1) && ISCHAR(2))        {
        char *szFile=hb_parc(1);
        char *szFiletoCompress=hb_parc(2);
        char *szNewFile;
        int iCompLevel;
        BOOL iReturn;
        BOOL iOverWrite;
        PHB_ITEM pBlock=hb_param( 4, HB_IT_BLOCK) ;
        if( ISNUM(3)) {
            iCompLevel=hb_parni(3);
        }
        else {
            iCompLevel= (-1);
            }
        if( ISLOG(5)) {
            iOverWrite=hb_parl(5);
        }
        else {
            iOverWrite= 1;
            }

        szNewFile=hb___CheckFile(szFile);
        iReturn=hb___CompressOneFile(szNewFile,szFiletoCompress,iCompLevel,pBlock,iOverWrite);
        hb_retl(iReturn);

}

    if(ISCHAR(1) && ISARRAY(2))        {
        PHB_ITEM pArray=hb_param( 2, HB_IT_ARRAY );
        PHB_ITEM pBlock=hb_param( 4, HB_IT_BLOCK) ;
        char *szFile=hb_parc(1);
        char *szNewFile;
        int iCompLevel;
        ULONG uiCount;
        BOOL iOverWrite;
        BOOL iReturn;
        if( ISNUM(3)) {
            iCompLevel=hb_parni(3);
        }
        else {
            iCompLevel= (-1);
            }
        if( ISLOG(5)) {
            iOverWrite=hb_parl(5);
        }
        else {
            iOverWrite= 1;
            }

        szNewFile=hb___CheckFile(szFile);
        iReturn=hb___CompressMultipleFile(szNewFile,pArray,iCompLevel,pBlock,iOverWrite);
        hb_retl(iReturn);

        }
      
}
HB_FUNC(HB_UNZIPFILE)
{
    if( ISCHAR(1)  ){
        char *szFile=hb_parc(1);
        char *szNewFile;
        int iCompLevel;
        PHB_ITEM pBlock=hb_param( 2, HB_IT_BLOCK) ;
        BOOL iReturn;
        szNewFile=hb___CheckFile(szFile);
        iReturn=hb___unZipFiles(szNewFile,pBlock);
        hb_retl(iReturn);
}
}

